﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using PartialUpdatesMvc.Models;

namespace PartialUpdatesMvc.Controllers
{
    public class HomeController : Controller
    {
        // Action par défaut (page d'accueil)
        // GET: /
        public ActionResult Index()
        {
            var users = GetUsers();

            return View(users);
        }

        // Vue partielle
        // GET: /home/weather
        public ActionResult Weather()
        {
            Random rnd  = new Random();
            double Temp = 22.0 + rnd.Next(0, 10) / 10.0;

            var weather = new WeatherViewModel() {
                Weather     = "Super Soleil",
                Temperature = Temp.ToString(),
                DateTime    = DateTime.Now.ToLongTimeString()
            };

            return PartialView(weather);
        }

        // Vue partielle
        // GET: /home/infotraffic
        public ActionResult InfoTraffic()
        {
            Random rnd      = new Random();
            string[] cities = new string[] { "Paris", "Lyon", "Marseille", "Metz", "Strasbourg" };
            
            // nombre de km de bouchons au total
            int kmBouchons = 5 + rnd.Next(10, 20);
            string ville   = cities[rnd.Next(cities.Length)];

            var traffic = new TrafficViewModel() {
                KmTotal = kmBouchons,
                Message = "Bouchons à " + ville
            };

            return PartialView(traffic);
        }

        // Générer une liste d'utilisateurs (créés au hasard)
        private List<Models.User> GetUsers()
        {
            var users       = new List<User>();
            var cities      = new string[] { "Paris", "London", "Berlin", "Strasbourg", "Grenoble", "Toulon", "Toulouse", "Metz" };
            string[] names1 = new string[] { "John", "Marie", "Pascal", "Paul", "Marc", "Sophie", "Sylvie" };
            string[] names2 = new string[] { "Smith", "Dubois", "Dupond", "Gates", "Lacroix", "Duprez" };

            Random rnd = new Random();

            for (int i = 0; i < 1000; i++)
            {
                string name = names1[rnd.Next(names1.Length)] + " " + names2[rnd.Next(names2.Length)];
                string city = cities[rnd.Next(cities.Length)];

                User u      = new User() { Name = name, City = city };
                users.Add(u);
            }
            return users;
        }
    }
}
